<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

if( ! $product->is_on_sale() ){
	return;
}

$regular_price = $product->get_regular_price();
$sale_price = $product->get_sale_price();

if( ! $regular_price || ! $sale_price ){
	return;
}

$price_diff = round( $regular_price - $sale_price );

if( ! $price_diff ){
	return;
}

$percent_diff = round( ( ( $price_diff / $regular_price ) * 100 ) );

$search = array(
	'[price_diff]',
	'[percent_diff]',
);

$replace = array(
	wcpt_price($price_diff),
	$percent_diff,
);

echo '<span class="wcpt-on-sale '. $html_class .'">'.  str_replace( $search, $replace, wcpt_parse_2( $template, $product ) ) .'</span>';
